////////////////////////////////////////////////////////////////////////
// EB Content Management System
// Copyright EB Dynamics, Inc., Edward Lemmers, P.E.
// Created: 4/9/2013	ELL

//////////////////////////////////////////////////////////////////////////////////////
function OpenHelpWindow()
{
	window.open("http://breezewebsitebuilder.com/docs/cms/help.html#edit_schedule", "Help", "scrollbars=1,resizable=1,status=0,toolbar=0,menubar=0,location=0,height=700,width=800");
}

//////////////////////////////////////////////////////////////////////////////////////
function DeleteConfirm(desc_remove, ID, y_offset)
{
	var ntop;
	ntop = tempY;
	if (ntop < 500)
		ntop = ntop + 20;
	else
		ntop = ntop - 20;
	var strtop = ntop + "px";
	
	document.getElementById("delete_confirm").style.display = "block";
	document.getElementById("delete_confirm").style.position = "absolute";
	document.getElementById("delete_confirm").style.top = strtop;
	document.getElementById("delete_confirm").style.left = "100px";
	document.getElementById("delete_confirm").style.width = "450px";
	document.getElementById("delete_confirm").style.backgroundColor = "#FFF";
	document.getElementById("delete_confirm").style.borderStyle = "solid";
	document.getElementById("delete_confirm").style.borderWidth = "2px";
	document.getElementById("delete_confirm").style.borderColor = "#000";
	document.getElementById("event_to_delete").value = ID;
	document.getElementById("row_to_delete").value = y_offset;
	document.getElementById("delete_text").innerHTML = desc_remove;
}

function DeleteEvent()
{
	var params = "";

	if (document.getElementById("StatusMsg").innerHTML == " ")
	{
		ShowStatusMsg();
		document.getElementById("StatusMsg").innerHTML = "Starting delete...";
	}
		
	var xmlhttp;
	xmlhttp = getXmlHttpRequestObject();

	if (xmlhttp.readyState == 4 || xmlhttp.readyState == 0)
	{
		xmlhttp.open("POST","delete_event.php",true);
		xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
		xmlhttp = UpdateMessage(xmlhttp, "StatusMsg", "DeleteEvent");
		params = "ID=" + document.getElementById("event_to_delete").value;
		params = params + "&desc_remove=" + document.getElementById("delete_text").innerHTML;
//		alert(params);
		xmlhttp.send(params);
	}
	document.getElementById("delete_confirm").style.display = "none";
}

function HideDelete()
{
	document.getElementById("delete_confirm").style.display = "none";
}

//////////////////////////////////////////////////////////////////////////////////////
function Update(j)
{
	if (!chkForm(j))
		return;
	var params = "";
	var ID_str = "ID" + j;
	var Description_str = "Description" + j;
	var EventDate_str = "EventDate" + j;
	var StartTime_str = "StartTime" + j;
	var EndTime_str = "EndTime" + j;
	var URL_str = "URL" + j;
	var Active_str = "Active" + j;
	var user_table_str = "selectUserTable" + j;
	var UserID_str = "selectUserID" + j;
	var AccessLevel_str = "selectAccessLevel" + j;
	
	if (document.getElementById("StatusMsg").innerHTML == " ")
	{
		ShowStatusMsg();
		document.getElementById("StatusMsg").innerHTML = "Starting update...";
	}
	
	var xmlhttp;
	xmlhttp = getXmlHttpRequestObject();

	if (xmlhttp.readyState == 4 || xmlhttp.readyState == 0)
	{
		xmlhttp.open("POST","save_event.php",true);
		xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
		xmlhttp = UpdateMessage(xmlhttp, "StatusMsg", "Update");
		params = "ID=" + document.getElementById(ID_str).value;
		params = params + "&Description=" + document.getElementById(Description_str).value;
		params = params + "&EventDate=" + document.getElementById(EventDate_str).value;
		params = params + "&StartTime=" + document.getElementById(StartTime_str).value;
		params = params + "&EndTime=" + document.getElementById(EndTime_str).value;
		params = params + "&URL=" + document.getElementById(URL_str).value;
		if (document.getElementById(Active_str).checked == true) params = params + "&Active=1";
		else params = params + "&Active=0";
		params = params + "&user_table=" + document.getElementById(user_table_str).value;
		params = params + "&UserID=" + document.getElementById(UserID_str).value;
		params = params + "&AccessLevel=" + document.getElementById(AccessLevel_str).value;
//		alert(params);
		xmlhttp.send(params);
	}
}

function chkForm(j)
{
	var bOKtoSend = true;
	var strItem;
	var dateField;
	var strDateField;
	
	strItem = "EventDate" + j;
	dateField = document.getElementById(strItem);
	//Remove white space for fair cheking of length.
	dateField.value = (dateField.value).replace(/^\s*|\s*$/g,'');
	strDateField = dateField.value;
	// Check for blank, incorrect legnth, or slashes not found in correct spot.
//		if ((strDateField == "") || (strDateField.length != 10) || (strDateField.indexOf("/") != 2) || (strDateField.lastIndexOf("/") != 5))
	if ((strDateField == "") || (strDateField.length != 10) || (strDateField.indexOf("-") != 4) || (strDateField.lastIndexOf("-") != 7))
	{
//			alert("Please fill in the date in the format of 'mm/dd/yyyy'.");
		alert("Please fill in the date in the format of 'yyyy-mm-dd'.");
		dateField.focus();
		bOKtoSend = false;
	}
	return(bOKtoSend);
}

//////////////////////////////////////////////////////////////////////////////////////
	function UpdateMessage(xmlhttp, StatusMsg_control_name, Source)
	{
		var query_complete_no_record = "Query complete.  No records found.";
		var query_complete = "<b>Query complete</b><br/>";
		var query_read_to_send = "Query ready to send...";
		var query_sent = "Query sent";
		var query_starting = "Locating events...";
		if (Source == "DeleteEvent")
		{
			query_complete_no_record = "No records found. Could not delete event.";
			query_complete = "<b>Event deleted</b><br/>";
			query_starting = "Deleting event...";
		}
		else if (Source == "Update")
		{
			query_complete_no_record = "No records found. Could not update event.";
			query_complete = "<b>Event updated</b><br/>";
			query_starting = "Updating event...";
		}
		else if (Source == "Populate")
		{
			query_complete_no_record = "No records found. Could not update user lists.";
			query_complete = "<b>User lists updated</b><br/>";
			query_starting = "Updating user lists...";
		}
		
		xmlhttp.onreadystatechange=function()
		{
			if (xmlhttp.readyState==4)
			{
				if (xmlhttp.responseText.length > 0)
				{
					var rows_str = xmlhttp.responseText;
					if (rows_str == "-no data-")
						document.getElementById(StatusMsg_control_name).innerHTML = query_complete_no_record;
					else
					{
						document.getElementById(StatusMsg_control_name).innerHTML = query_complete;
						if (Source == "DeleteEvent")
						{
							document.getElementById(StatusMsg_control_name).innerHTML = rows_str;
							var tr_j = "tr_" + document.getElementById("row_to_delete").value;
							document.getElementById(tr_j).style.display = "none";
						}
						else if (Source == "Update")
						{
							document.getElementById(StatusMsg_control_name).innerHTML = rows_str;
							// Look for insert.
							if ((rows_str.indexOf("has been added.", 5)) > 0)
							{
								var id_arr = rows_str.split("[");
								var id = id_arr[1];
								id_arr = "";
								id_arr = id.split("]");
								id = id_arr[0];
								j = document.getElementById("rec_cnt").value - 1;
								var ID_str = "ID" + j;
								document.getElementById(ID_str).value = id;
								var tr_j = "tr_" + j;
								if (j%2)
									document.getElementById(tr_j).bgColor = "#EEEEEE";
								else
									document.getElementById(tr_j).bgColor = "#DDDDDD";
							}
						}
						else if (Source == "Populate")
						{	PopulateUsers(rows_str);	}
					}
				}
				else
					document.getElementById(StatusMsg_control_name).innerHTML = query_complete_no_record;

				var ClearMessageString = "ClearMessage('" + StatusMsg_control_name + "');";
				mTimer = setTimeout(ClearMessageString, 2000);
			}
			else if (xmlhttp.readyState==1)
				document.getElementById(StatusMsg_control_name).innerHTML = query_read_to_send;
			else if (xmlhttp.readyState==2)
				document.getElementById(StatusMsg_control_name).innerHTML = query_sent;
			else if (xmlhttp.readyState==3)
				document.getElementById(StatusMsg_control_name).innerHTML = query_starting;
		}
		return (xmlhttp);
	}

//////////////////////////////////////////////////////////////////////////////////////
function ClearMessage(StatusMsg_control_name)
{
	HideStatusMsg();
	document.getElementById(StatusMsg_control_name).innerHTML = " ";
	clearInterval(mTimer);
}

////////////////////////////////////////////////////////////////////////////////////
function AddEvent()
{
	var j = document.getElementById("rec_cnt").value;
	var k = document.getElementById("row_cnt").value;
	var tr_j = "tr_" + j;
	document.getElementById(tr_j).style.display = "table-row";
	document.getElementById(tr_j).bgColor = "#FFFF99";

	/////////// Increment record count //////////////////
	j++;
	document.getElementById("rec_cnt").value = j;
	
	///// Check for spare rows, and if all used up, recommend save and refresh. /////
	if (j >= k)
	{
		var top = (k * 59);
		document.getElementById("refresh_required").style.display = "block";
		document.getElementById("refresh_required").style.position = "absolute";
		document.getElementById("refresh_required").style.top = top;
		document.getElementById("refresh_required").style.left = "100px";
		document.getElementById("refresh_required").style.width = "450px";
		document.getElementById("refresh_required").style.backgroundColor = "#FFF";
		document.getElementById("refresh_required").style.borderStyle = "solid";
		document.getElementById("refresh_required").style.borderWidth = "2px";
		document.getElementById("refresh_required").style.borderColor = "#000";
	}
}

function HideRefreshRequired()
{
	document.getElementById("refresh_required").style.display = "none";
}

//////////////////////////////////////////////////////////////////////////////////////
var selected_row = -1;

function RetrieveUsers(user_table, i)
{	
	selected_row = i;
	
	if (document.getElementById("StatusMsg").innerHTML == " ")
	{
		ShowStatusMsg();
		document.getElementById("StatusMsg").innerHTML = "Starting user query...";
	}
	var xmlhttp;
	xmlhttp = getXmlHttpRequestObject();

	if (xmlhttp.readyState == 4 || xmlhttp.readyState == 0)
	{
		xmlhttp.open("POST","../populate_users.php",true);
		xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
		xmlhttp = UpdateMessage(xmlhttp, "StatusMsg", "Populate");
		params = "user_table=" + user_table + "&page=0&max_rec=10000";
//		alert(params);
		xmlhttp.send(params);
	}
}

function PopulateUsers(rows_str)
{
	var rows = new Array();

	var output_str = "<select name='selectUserID" + selected_row + "' id='selectUserID" + selected_row + "'>\n";
	output_str = output_str + "<option>-not selected-</option>\n";

	rows = rows_str.split("@@@@@");
	if (rows[0] == "-no data-")	// If no pages yet (first time).
		var i = 0;
	else	// Create options for access level list.
	{
		for (var i in rows)
		{
			var JSON_row = JSON.parse(rows[i]);
			if (JSON_row.UserID)
				output_str = output_str + "<option value='" + JSON_row.UserID + "'>" + JSON_row.UserID + "</option>\n";
		}
	}
	output_str = output_str + "<\/select>\n";
	
	var UserID_td_str = "UserID" + selected_row + "_td";
	document.getElementById(UserID_td_str).innerHTML = output_str;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
function ShowStatusMsg()
{
	var ntop;
	ntop = tempY;
	
	if (ntop < 500)
		ntop = ntop - 20;
	else
		ntop = ntop - 40;
	var strtop = ntop + "px";
	
	document.getElementById("popup_msg_div").style.display = "block";
	document.getElementById("popup_msg_div").style.position = "absolute";
	document.getElementById("popup_msg_div").style.top = strtop;
	document.getElementById("popup_msg_div").style.left = "500px";
}

function ShowStatusMsgCloseBtn()
{
	document.getElementById("popup_msg_close_btn").style.display = "inline";
}

function HideStatusMsg()
{
	document.getElementById("popup_msg_div").style.display = "none";
	document.getElementById("popup_msg_close_btn").style.display = "none";
	document.getElementById("StatusMsg").innerHTML = " ";
}